package com.collabnet.ctf.ejb;

import java.util.List;
import java.util.Random;

import javax.inject.Inject;

import junit.framework.TestCase;

import org.jboss.arquillian.container.test.api.Deployment;
import org.jboss.shrinkwrap.api.Archive;
import org.jboss.shrinkwrap.api.ShrinkWrap;
import org.jboss.shrinkwrap.api.asset.EmptyAsset;
import org.jboss.shrinkwrap.api.spec.EnterpriseArchive;
import org.jboss.shrinkwrap.api.spec.JavaArchive;
import org.jboss.shrinkwrap.resolver.api.maven.Maven;

/**
 * CollabNet TeamForge(r)
 * Copyright 2007-2013 CollabNet, Inc. All rights reserved.
 * http://www.collab.net
 */
public abstract class JPATest <B, D extends B> extends TestCase {

	@Deployment
	public static Archive<?> createDeployment() {


		final JavaArchive ejbs = ShrinkWrap.create(JavaArchive.class, "mercury-ejbs.jar")
			.addPackages(true, "com.company.artifact.ejb")
			.addAsManifestResource(EmptyAsset.INSTANCE, "beans.xml");

		final JavaArchive[] libs = Maven.resolver().offline().loadPomFromFile("pom.xml")
			.importRuntimeAndTestDependencies().resolve()
			.withTransitivity().as(JavaArchive.class);

		/**
		 * The following should be the same maven artifact for delivering to the container
		 */
		final EnterpriseArchive ear = ShrinkWrap.create(EnterpriseArchive.class, "mercury.ear")
			.addAsModule(ejbs)
			.addAsLibraries(libs)
			.addAsManifestResource("META-INF/persistence.xml", "persistence.xml")
			.setApplicationXML("application.xml");

		return ear;
	}

    public void setUp() throws Exception {
        super.setUp();
    }

    @Override
    public void tearDown() throws Exception {
        super.tearDown();

    }

    /**
     * Create a random, (almost definitely) unique id
     *
     * @return a mostly random id
     */
    public static int getRandomId() {
        return new Random().nextInt(Integer.MAX_VALUE);

    }

    /**
     * Create a random, (almost definitely) unique SfName
     *
     * @param prefix prepend this to the name
     *
     * @return a mostly random name
     */
    protected static String getRandomSfName(String prefix) {
        return prefix + new Random().nextInt(Integer.MAX_VALUE);

    }
}
